let tablaEstudiante

const helpers = {
	recargarTablaEstudiante() {
		let nombreEstudiante = $('#txtNombreEstudiante').val()
		tablaEstudiante.destroy()
		initComponents.listarAlumnos({
			nombreEstudiante: nombreEstudiante.trim().length > 0 ? nombreEstudiante : undefined
		})
	}
}



const httpRequest = {
	listarDepartamento(json) {
		return new Promise((resolve, reject) => {
			$.ajax({
				type: 'POST',
				url: "../UbigeoServlet?accion=listarDepartamento",
				dataType: "json",
				data: {
					json: JSON.stringify(json)
				},
				success: function (data, textStatus, jqXHR) {
					resolve(data)
				}, error: function (jqXHR, textStatus, errorThrown) {
					reject('Error en la petición')
				}
			})
		})
	},
	listarProvinciaById(json) {
		return new Promise((resolve, reject) => {
			$.ajax({
				type: 'POST',
				url: "../UbigeoServlet?accion=listarProvincia",
				dataType: "json",
				data: {
					json: JSON.stringify(json)
				},
				success: function (data, textStatus, jqXHR) {
					resolve(data)
				}, error: function (jqXHR, textStatus, errorThrown) {
					reject('Error en la petición')
				}
			})
		})
	},
	listarDistritoById(json) {
		return new Promise((resolve, reject) => {
			$.ajax({
				type: 'POST',
				url: "../UbigeoServlet?accion=listarDistrito",
				dataType: "json",
				data: {
					json: JSON.stringify(json)
				},
				success: function (data, textStatus, jqXHR) {
					resolve(data)
				}, error: function (jqXHR, textStatus, errorThrown) {
					reject('Error en la petición')
				}
			})
		})
	}
}

//CONSTANTE QUE NOS PERMITE EJECUTAR LOS METODOS CREADOS EN LA CONSTANTE HttpRequest
const initRequest = {
	init() {
		this.cargarDepartamento()
//        this.cargarProvincia()
//        this.cargaDistrito()
	},
	cargarDepartamento() {
		httpRequest.listarDepartamento({})
			.then(data => {
				let print = '<option>[SELECCIONE]</option>'
				if (data.status) {
					//LA FUNCION <MAP> PERMITE ITERAR MEDIANTE UN BUCLE LOS ELEMENTOS DE UN ARRAY O LISTA Y MANIPULARLOS DURANTE SU EJECUCION, ES MUY PARECIDA A LA
					//FUNCION EACH, CON AMBAS FUNCIONES SE PUEDEN OBTENER PRACTICAMENTE LOS MISMOS RESULTADOS
					print += data.results.map(obj => '<option value="' + obj.codigoDepartamento + '">' + obj.nombreDepartamento + '</option>').join('')
				}
				document.querySelector('#cboDepartamento').innerHTML = print
//                    $('#cboDepartamento').html(print)
			})
	},
	cargarProvincia(json) {
		httpRequest.listarProvinciaById(json)
			.then(data => {
				let print = '<option>[SELECCIONE]</option>'
				if (data.status) {
					print += data.results.map(obj => '<option value="' + obj.codigo_provincia + '">' + obj.nombre_provincia + '</option>').join('')
				}
				document.querySelector('#cboProvincia').innerHTML = print
//                    $('#cboDepartamento').html(print)
			})
	},
	cargaDistrito(json) {
		httpRequest.listarDistritoById(json)
			.then(data => {
				let print = '<option>[SELECCIONE]</option>'
				if (data.status) {
					print += data.results.map(obj => '<option value="' + obj.codigo_distrito + '">' + obj.nombre_distrito + '</option>').join('')
				}
				document.querySelector('#cboDistrito').innerHTML = print
			})
	}

}

const DOMEvents = {
	init() {
//		this.changeDepartamentos()
//		this.changeProvincia()
		this.buscarEstudiante()
		this.limpiarBotonEstudiante()
	},
	changeDepartamentos() {
		$('#cboDepartamento').change((e) => {
			let _this = e.currentTarget
			let option = $(_this).val()
			initRequest.cargarProvincia({
				codigoDepartamento: option
			})
			$("#cboDistrito").html('<option>[SELECCIONE]</option>')
		})
	},
	changeProvincia() {
		$("#cboProvincia").change((e) => {
			let _this = e.currentTarget
			let option = $(_this).val()
			initRequest.cargaDistrito({
				codigoProvincia: option,
				codigoDepartamento: option
			})
		})
	},
	clickEliminarEstudiante() {
		$('#tblEstudiante tbody').on('click', '.eliminar', function () {
			console.log('hola');
		});
	},
	buscarEstudiante() {
		$('#btnBuscar').click(() => {
			helpers.recargarTablaEstudiante()
		})
	},
	limpiarBotonEstudiante(){
		$('#btnLimpiar').on('click',function(){
			  //console.log('limpiando');
				$('#txtNombreEstudiante').val("");
				//initComponents.listarAlumnos({});
		});
		
	}
}

const initComponents = {
	init() {
		this.listarAlumnos({})
	},
	listarAlumnos(json) {
		tablaEstudiante = $("#tblEstudiante").DataTable({
			"language": {
				"lengthMenu": "Mostrar: _MENU_",
				"zeroRecords": "&nbsp;&nbsp;&nbsp; No se encontraron resultados",
				"info": "&nbsp;&nbsp;&nbsp; Mostrando del _START_ al _END_ de un total de _TOTAL_ registros",
				"infoEmpty": "&nbsp;&nbsp;&nbsp; Mostrando 0 de 0 registros",
				"search": "Filtrar:",
				"loadingRecords": "Cargando...",
				"processing": '<span style="width:100%;"><img src="http://www.snacklocal.com/images/ajaxload.gif"></span>',
				"paginate": {
					"first": "First",
					"last": "Last",
					"next": "Siguiente",
					"previous": "Anterior"
				}
			}, "searching": false,
			dom: '<"datatable-scroll"t>r<"datatable-footers"ip>',
			"ajax": {
				type: 'POST',
				url: "../UbigeoServlet?accion=listarAlumnos",
				data: {
					json: JSON.stringify(json)
				}
			},
			"bSort": false,
			"bFilter": false,
			"serverSide": true,
			"processing": true,
			"aaSorting": [],
			"ordering": false,
			"bLengthChange": false,
			"bInfo": true,
			"paging": true,
			"iDisplayLength": 10,
			"columnDefs": [

				{targets: 0, orderable: false, width: "5%", className: "text-center"},
				{targets: 1, orderable: false, width: "15%"},
				{targets: 2, orderable: false, width: "15%"},
				{targets: 3, orderable: false, width: "7%", className: "text-center"}
			],
			"columns": [
				{"data": "numeral"},
				{"data": "nombrealumno", "render": (data, type, row) => {
						return capitalizeWords(data);
					}
				},
				{"data": "apellidoalumno", "render": (data, type, row) => {
						return capitalizeWords(data)
					}
				},
				{"data": null, "render": (data, type, row) => {
						var actions = "";
						actions += `<span data-toggle="tooltip" data-placement="left" title="Eliminar" style="cursor: pointer"> <i class='eliminar glyphicon glyphicon-trash text-danger-700'></i></span>`
						return actions;
					}
				}
			],
			fnDrawCallback: () => {
				loader.terminarLoader()
				DOMEvents.clickEliminarEstudiante()
				DOMEvents.limpiarBotonEstudiante()
			}
		});
	}

}

init = () => {
//	initRequest.init()
	DOMEvents.init()
	initComponents.init()

}

init()

/*
 cargarDepartamentoById(){
 var select = document.getElementById('#cboDepartamento');
 select.addEventListener('change',
 function () {
 var selectedOption = this.options[select.selectedIndex];
 alert(selectedOption.value + ': ' + selectedOption.text);
 });
 
 }*/





